/*
 * Copyright 2002-2019 Intel Corporation.
 * 
 * This software and the related documents are Intel copyrighted materials, and your
 * use of them is governed by the express license under which they were provided to
 * you ("License"). Unless the License provides otherwise, you may not use, modify,
 * copy, publish, distribute, disclose or transmit this software or the related
 * documents without Intel's prior written permission.
 * 
 * This software and the related documents are provided as is, with no express or
 * implied warranties, other than those that are expressly stated in the License.
 */

// <COMPONENT>: util
// <FILE-TYPE>: component public header

#ifndef UTIL_HPP
#define UTIL_HPP

/*! @mainpage UTIL library
 *
 * The UTIL library provides a collection of generally useful utilities.
 */

/*! @brief The UTIL library. */
namespace UTIL {}

#include "util/data.hpp"
#include "util/intel-fp.hpp"
#include "util/locker.hpp"
#include "util/numberbits.hpp"
#include "util/quote-argument-ms.hpp"
#include "util/range.hpp"
#include "util/regvalue.hpp"
#include "util/round.hpp"
#include "util/scoped-ptr.hpp"
#include "util/scoped-array.hpp"
#include "util/strings.hpp"
#include "util/singleton.hpp"

#endif // file guard
